package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.Tag;
import com.izouma.dingdong.service.backstage.TagService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.TagRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/tag")
@AllArgsConstructor
public class TagController extends BaseController {
    private TagService tagService;
    private TagRepo tagRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Tag save(@RequestBody Tag record) {
        if (record.getId() != null) {
            Tag orig = tagRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return tagRepo.save(orig);
        }
        return tagRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Tag> all(PageQuery pageQuery) {
        return tagRepo.findAll(toSpecification(pageQuery,Tag.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Tag get(@PathVariable Long id) {
        return tagRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        tagRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Tag> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

